#pragma once
#include "stdafx.h"



class Event
{
public:
	Event();
	int id;
	int nrId;
	int typeId;
	int match;
	int team;
    int home; // =1 if the team is playing at home
	int status;
	int manpower;
	double x;
	double y;
	double endX;
	double endY;
	int half;
	int min;
	double sec;
	int player;
	int outcome;
	double lengthToGoal; // hvis skudd
	double angleToGoal; // hvis skudd
	std::string ass; // hvis skudd
	std::string playType; // hvis skudd
	double carryLength; // hvis skudd
	int numberOfDribbles; // hvis skudd
	int fieldRoughZone; // hvis skudd, har verdier fra 0 til x
	//int fieldZone; // fin-masket omrde i 16-meteren og utenfor 16-meteren i x-retning
	//int numQualifiers;
	std::vector<int> qId;
	std::vector<double> values;
	int assistId; // hvis skudd og assist
	int assistToType; // hva slags avslutning frte innlegget/pasningen til
	~Event();

	void calculateLengthAndAngle();
	bool qualExist(int id);
	double findQualVal(int id);
	bool operator<(const Event& rhs);
	bool operator==(const Event& rhs);
	bool operator!=(const Event& rhs);
	void findEnd(double& x, double& y);
	void setEnd();
	bool isCross();
	bool isCorner();
	bool isPass(); // vanlig pasning
	bool isSuccPass(); // vellykket pasning
	bool isLongPass(); // langpasning
	bool isForwardPass(); // pasning fremover
	bool isAllPasses(); // vanlig, lang eller innlegg
	bool isShotOnTarget(); // skudd p ml
	bool isYellow(); // gule kort
	bool isTackle();
	bool isWonTackle(); // betyr at ballen vinnes og gr til eget lag eller ut av spill
	bool isFastBreak(); // per Optas definisjon
	bool isBallWin(); // ball vunnet alle mter
	bool isRedundant2(); // annet som ikke trengs
    bool isBreakEvent(); //bryter en sekvens: ml, ball ut av spill
    bool isRedudant(); // eventer der spiller lager frispark, taper hodeduell, lager corner, gule kort
    bool isFreeKick();
    bool isGKEvent();
	
	void findRoughFieldZone();
	void findFieldZone();
	
	// TIL MARKOV
	bool isStartEvent(); // kick-off, throw-in, goal kick or keeper throw
	bool isShot(); // all shots (13,14,15,16)
	void setTimePeriod(); // finds the time periods

	int markovId; //
	int markovPeriod; // 1,2,3 or 4
	int markovSeq;
	int fieldZone;
	int fieldZoneEnd;
	int markovEndZone;


};


