#include "stdafx.h"
#include "Match.h"
#include "functions.h"
#include "Event.h"

using namespace std;

Match::Match() {}

Match::~Match() {}

int Match::countPasses(int flag, int succ) { // counts the number of (successful) passes for a given team
	int count = 0;
	if (flag == 1 && succ == 1) { // home team successful
		for (unsigned int i = 0;i < eventsH.size();i++) {
			if (eventsH[i].typeId == 1 && eventsH[i].outcome == 1 && qualExist(eventsH[i], 2) == false && qualExist(eventsH[i], 107) == false && qualExist(eventsH[i], 123) == false) { count++; }
		}
	}
	else if (flag == 2 && succ == 1) { // away team successful
		for (unsigned int i = 0;i < eventsA.size();i++) {
			if (eventsA[i].typeId == 1 && eventsA[i].outcome == 1 && qualExist(eventsA[i], 2) == false && qualExist(eventsA[i], 107) == false && qualExist(eventsA[i], 123) == false) { count++; }
		}
	}
	else if (flag == 1 && succ == 0) {
		for (unsigned int i = 0;i < eventsH.size();i++) {
			if (eventsH[i].typeId == 1 && qualExist(eventsH[i], 2) == false && qualExist(eventsH[i], 107) == false && qualExist(eventsH[i], 123) == false) { count++; }
		}
	}
	else if (flag == 2 && succ == 0) {
		for (unsigned int i = 0;i < eventsA.size();i++) {
			if (eventsA[i].typeId == 1 && qualExist(eventsA[i], 2) == false && qualExist(eventsA[i], 107) == false && qualExist(eventsA[i], 123) == false) { count++; }
		}
	}
	return count;
}

void Match::sortEvents() { // sorts all the events for each team in a match
	int length = this->eventsH.size();
	for (int i = 0;i < length;++i) {
		bool swapped = false;
		for (int j = 0;j < length - (i + 1); ++j) {
			if ((this->eventsH[j] < this->eventsH[j + 1]) == false) {
				Event temp = this->eventsH[j];
				this->eventsH[j] = this->eventsH[j + 1];
				this->eventsH[j + 1] = temp;
				swapped = true;
			}
		}
		if (!swapped) break;
	}

	length = this->eventsA.size();
	for (int i = 0;i < length;++i) {
		bool swapped = false;
		for (int j = 0;j < length - (i + 1); ++j) {
			if ((this->eventsA[j] < this->eventsA[j + 1]) == false) {
				Event temp = this->eventsA[j];
				this->eventsA[j] = this->eventsA[j + 1];
				this->eventsA[j + 1] = temp;
				swapped = true;
			}
		}
		if (!swapped) break;
	}
	
	length = this->allEvents.size();
	for (int i = 0;i < length;++i) {
		bool swapped = false;
		for (int j = 0;j < length - (i + 1); ++j) {
			if ((this->allEvents[j] < this->allEvents[j + 1]) == false) {
				Event temp = this->allEvents[j];
				this->allEvents[j] = this->allEvents[j + 1];
				this->allEvents[j + 1] = temp;
				swapped = true;
			}
		}
		if (!swapped) break;
	}
    for (int i = 0;i<length;++i){
        if (allEvents[i].team == home){
            allEvents[i].home = 1;
        }else if (allEvents[i].team == away){
            allEvents[i].home = 0;
        }else{
            allEvents[i].home = -1;
        }
    }
	
}

void Match::countGoalsAndLog() {
	int h = 0;
	int a = 0;
	int length = this->eventsH.size();
	for (int i = 0;i < length;++i) {
		if (this->eventsH[i].typeId == 16 ) {
			if (!qualExist(eventsH[i], 28)) {
				h++;
			}
			else {
				a++;
			}
		}
	}
	length = this->eventsA.size();
	for (int i = 0;i < length;++i) {
		if (this->eventsA[i].typeId == 16) {
			if (!qualExist(eventsA[i], 28)) {
				a++;
			}
			else {
				h++;
			}
		}
	}
	goalsH = h;
	goalsA = a;
	if (h > a) {
		logH = 1;
		logA = 3;
	}
	else if (h == a) {
		logH = 2;
		logA = 2;
	}
	else {
		logH = 3;
		logA = 1;
	}
}

void Match::createStatus() { // creates status-variables for each event and match
	int maal = 0;
	int length = this->eventsH.size();
	for (int i = 0;i < length;++i) {
		if (this->eventsH[i].typeId == 16) {
			this->goalEvents.push_back(this->eventsH[i]);
			maal++;
		}
	}
	length = this->eventsA.size();
	for (int i = 0;i < length;++i) {
		if (this->eventsA[i].typeId == 16) {
			this->goalEvents.push_back(this->eventsA[i]);
			maal++;
		}
	}
	this->goals = maal;
	this->homeStatus.push_back(0);
	this->awayStatus.push_back(0);
    sortEventVector(goalEvents);
	//sort(this->goalEvents.begin(), this->goalEvents.end());
	
	length = this->goalEvents.size();
	for (int i = 0;i < length;++i) {
		if ((this->goalEvents[i].team == this->home && !qualExist(this->goalEvents[i],28)) || (this->goalEvents[i].team == this->away && qualExist(this->goalEvents[i],28))) {
			int h = this->homeStatus[i];
			int a = this->awayStatus[i];
			this->homeStatus.push_back(h+1);
			this->awayStatus.push_back(a-1);

			for (unsigned int j = 0;j < this->eventsH.size();++j ) {
				if (this->goalEvents[i] < this->eventsH[j]) {
					this->eventsH[j].status++;
				}
			}
			for (unsigned int j = 0;j < this->eventsA.size();++j ) {
				if (this->goalEvents[i] < this->eventsA[j]) {
					this->eventsA[j].status--;
				}
			}
		}
		else {
			int h = this->homeStatus[i];
			int a = this->awayStatus[i];
			this->homeStatus.push_back(h-1);
			this->awayStatus.push_back(a+1);

			for (unsigned int j = 0;j < this->eventsH.size();++j) {
				if (this->goalEvents[i] < this->eventsH[j]) {
					this->eventsH[j].status--;
				}
			}
			for (unsigned int j = 0;j < this->eventsA.size();++j) {
				if (this->goalEvents[i] < this->eventsA[j]) {
					this->eventsA[j].status++;
				}
			}
		}
	}
    int h = 0;
    int a = 0;
    for (unsigned int i = 0;i<allEvents.size();i++){
        if (allEvents[i].team == home){
            if (eventsH[h].status > 0){
                allEvents[i].status = 1;
            }else if (eventsH[h].status == 0){
                allEvents[i].status = 0;
            }else{
                allEvents[i].status = -1;
            }
            h++;
        }
        else if (allEvents[i].team == away){
            if (eventsA[a].status > 0){
                allEvents[i].status = 1;
            }else if (eventsA[a].status == 0){
                allEvents[i].status = 0;
            }else{
                allEvents[i].status = -1;
            }
            a++;
        }
    }
    
}

Event Match::findLast(int period) { // finds the last event in a given period
	Event ut;
	for (unsigned int i = 0;i < this->eventsH.size();++i) {
		if (this->eventsH[i].half == period && this->eventsH[i].typeId == 30) { 
			ut = eventsH[i];
			break;
		}
	}
	return ut;
}

Event Match::findFirst(int period) { // finds the first event in a given period
	Event ut;
	for (unsigned int i = 0;i < this->eventsH.size();++i) {
		if (this->eventsH[i].half == period && this->eventsH[i].typeId == 32) {
			ut = eventsH[i];
			break;
		}
	}
	return ut;
}


Event Match::findAssistEvent(Event& e) {
	Event ut;
	if (e.team == home) {
		double eId = e.findQualVal(55);
		int id = (int)eId;
		e.assistId = id;
		for (unsigned int i = 0;i < eventsH.size();i++) {
			if (eventsH[i].nrId == id) {
				ut = eventsH[i];
				break;
			}
		}
	}
	else {
		double eId = e.findQualVal(55);
		int id = (int)eId;
		e.assistId = id;
		for (unsigned int i = 0;i < eventsA.size();i++) {
			if (eventsA[i].nrId == id) {
				ut = eventsA[i];
				e.assistId = eventsA[i].nrId;
				break;
			}
		}
	}
	return ut;
}

void Match::getCarryInfo(Event& skudd, Event& assist) { // hvis skuddet har en assist (q=29 eksisterer)
	int count = 0;
	int s, a;
	if (skudd.team == home) {
		for (int i = 0;i < eventsH.size();i++) {
			if (assist == eventsH[i]) { a = i; }
			else if (skudd == eventsH[i]) { s = i; }
		}
		for (int j = a;j < s;j++) {
			if (eventsH[j].typeId == 3) { count++; }
		}
	}
	else {
		for (int i = 0;i < eventsA.size();i++) {
			if (assist == eventsA[i]) { a = i; }
			else if (skudd == eventsA[i]) { s = i; }
		}
		for (int j = a;j < s;j++) {
			if (eventsA[j].typeId == 3) { count++; }
		}
	}
	if ((assist.typeId == 13 && qualExist(assist, 153)) || assist.typeId == 50 || assist.typeId == 15) {
		skudd.carryLength = 0;
	}
	else {
		double endX, endY;
		assist.findEnd(endX, endY);
		skudd.carryLength = sqrt(pow(skudd.x - endX, 2) + pow(skudd.y - endY, 2));
	}
	skudd.numberOfDribbles = count;
}

void Match::getCarryInfo(Event& skudd) { // hvis skuddet ikke har en assist
	int count = 0;
	Event start = skudd;
	int s = 0;
	if (skudd.team == home) {
		for (int i = 0;i < eventsH.size();i++) {
			if (eventsH[i].id == skudd.id) {
				s = i - 1;
				while (!eventsH[s].isBallWin() && eventsH[s].player == skudd.player) {
					if (eventsH[s].typeId == 3) {
						count++;
					}
					s--;
					start = eventsH[s];
				}
			}
		}
	}
	else {
		for (int i = 0;i < eventsA.size();i++) {
			if (eventsA[i].id == skudd.id) {
				s = i - 1;
				while (!eventsA[s].isBallWin() && eventsA[s].player == skudd.player) {
					if (eventsA[s].typeId == 3) {
						count++;
					}
					s--;
					start = eventsA[s];
				}
			}
		}
	}
	skudd.carryLength = sqrt(pow(skudd.x - start.x, 2) + pow(skudd.y - start.y, 2));
	skudd.numberOfDribbles = count;
}


void Match::categorizeGoals() {
	goalSequencesType = new string[goals];
	string pop, ass, loc, alt;
	for (unsigned int i = 0;i < goals;++i) {
		pop = playingPattern(goalEvents[i]);
		ass = assist(goalEvents[i], goalSequences[i][1]);
		loc = goalLocation(goalEvents[i]);
		alt = pop;
		alt.append(", ");
		alt.append(ass);
		alt.append(", ");
		alt.append(loc);
		goalSequencesType[i] = alt;
	}
}

double Match::timeBetween(Event& start, Event& end) {
	double m, s;
	if (start.half == end.half) {
		m = end.min - (start.min + 1);
		s = (60 - start.sec) / 60 + end.sec / 60;
		return m + s;
	}
	else {
		Event omg = findLast(1);
		m = omg.min - (start.min + 1) + end.min - 45;
		s = (60 - start.sec) / 60 + omg.sec / 60 + end.sec / 60;
		return m + s;
	}
}


// TIL MARKOV

void Match::createManpower() { // creates manpower-variables for each event and match
	int rod = 0;
	vector<Event> rode;
	int length = this->eventsH.size();
	for (int i = 0;i < length;++i) {
		this->eventsH[i].manpower = 0;
		if (this->eventsH[i].typeId == 17 && (this->eventsH[i].qualExist(32) || this->eventsH[i].qualExist(33))) {
			rode.push_back(this->eventsH[i]);
			rod++;
		}
	}
	length = this->eventsA.size();
	for (int i = 0;i < length;++i) {
		this->eventsA[i].manpower = 0;
		if (this->eventsA[i].typeId == 17 && (this->eventsA[i].qualExist(32) || this->eventsA[i].qualExist(33))) {
			rode.push_back(this->eventsA[i]);
			rod++;
		}
	}
    sortEventVector(rode);
	//sort(rode.begin(), rode.end());

	length = rode.size();
	for (int i = 0;i < length;++i) {
		if (rode[i].team == this->home) {
			for (unsigned int j = 0;j < this->eventsH.size();++j) {
				if (rode[i] < this->eventsH[j]) {
					this->eventsH[j].manpower--;
				}
			}
			for (unsigned int j = 0;j < this->eventsA.size();++j) {
				if (rode[i] < this->eventsA[j]) {
					this->eventsA[j].manpower++;
				}
			}
		}
		else {
			for (unsigned int j = 0;j < this->eventsH.size();++j) {
				if (rode[i] < this->eventsH[j]) {
					this->eventsH[j].manpower++;
				}
			}
			for (unsigned int j = 0;j < this->eventsA.size();++j) {
				if (rode[i] < this->eventsA[j]) {
					this->eventsA[j].manpower--;
				}
			}
		}
	}
    int h = 0;
    int a = 0;
    for (unsigned int i = 0;i<allEvents.size();i++){
        if (allEvents[i].team == home){
            allEvents[i].manpower = eventsH[h].manpower;
            h++;
        }else if (allEvents[i].team == away){
            allEvents[i].manpower = eventsA[a].manpower;
            a++;
        }
    }
}

void Match::setTimePeriods() {
	for (unsigned int i = 0;i < eventsH.size();i++) {
		eventsH[i].setTimePeriod();
	}
	for (unsigned int i = 0;i < eventsA.size();i++) {
		eventsA[i].setTimePeriod();
	}
    for (unsigned int i = 0;i<allEvents.size();i++){
        allEvents[i].setTimePeriod();
    }
}

// denne frste bruker ball ut av spill som sekvens-start
void Match::createMarkovSequences() {
	vector<vector<Event>> ut;
	for (unsigned int i = 0;i < allEvents.size();i++) {
		if (allEvents[i].isShot()) {
			vector<Event> s;
			unsigned int j = i;
			while (!allEvents[j].isStartEvent()) {
				s.push_back(allEvents[j]);
				j--;
			}
			s.push_back(allEvents[j]);
			ut.push_back(s);
		}
	}
	markov = ut;
}

// denne ser fra laget som skjt vant ballen
void Match::createMarkovSequences2() {
	vector<vector<Event>> ut;
	for (unsigned int i = 0;i < eventsH.size();i++) {
		if (eventsH[i].isShot()) {
			vector<Event> s;
			unsigned int j = i;
			while ( (!eventsH[j].isBallWin() && !eventsH[j].isStartEvent() && eventsH[j].typeId != 17 && eventsH[j].outcome == 1) || (eventsH[j].typeId == 5) || (eventsH[j+1].typeId == 4 && eventsH[j+1].qualExist(10) ) ) {
				if (eventsH[j].typeId != 5 && eventsH[j].typeId != 10 && !eventsH[j].isRedundant2() && !eventsH[j].qualExist(132)) {
					s.push_back(eventsH[j]);
				}
				j--;
			}
			if ((eventsH[j].outcome == 1 || s.back().typeId == 6) && eventsH[j].typeId != 10 && eventsH[j].typeId != 17 && !eventsH[j].isRedundant2() && !eventsH[j].qualExist(132) && !eventsH[j].qualExist(10) && eventsH[j].player != 0 ) {
				s.push_back(eventsH[j]);
			}
			reverse(s.begin(), s.end());
			if (s[0].typeId == 4 && s[0].qualExist(10)) {
				s.erase(s.begin());
			}
			ut.push_back(s);
		}
	}
	for (unsigned int i = 0;i < eventsA.size();i++) {
		if (eventsA[i].isShot()) {
			vector<Event> s;
			unsigned int j = i;
			while ((!eventsA[j].isBallWin() && !eventsA[j].isStartEvent() && eventsA[j].typeId != 17 && eventsA[j].outcome == 1) || (eventsA[j].typeId == 5) || (eventsA[j+1].typeId == 4 && eventsA[j+1].qualExist(10) ) ) {
				if (eventsA[j].typeId != 5 && eventsA[j].typeId != 10 && !eventsA[j].isRedundant2() && !eventsA[j].qualExist(132)) {
					s.push_back(eventsA[j]);
				}
				j--;
			}
			if ((eventsA[j].outcome == 1 || s.back().typeId == 6) && eventsA[j].typeId != 10 && eventsA[j].typeId != 17 && !eventsA[j].isRedundant2() && !eventsA[j].qualExist(132) && !eventsA[j].qualExist(10) && eventsA[j].player != 0 ) {
				s.push_back(eventsA[j]);
			}
			reverse(s.begin(), s.end());
			if (s[0].typeId == 4 && s[0].qualExist(10)) {
				s.erase(s.begin());
			}
			ut.push_back(s);
		}
	}
	markov = ut;
}

void Match::createSequences(){
    for (unsigned int i = 0;i<allEvents.size();i++){
        if (allEvents[i].isBreakEvent()){
            vector<Event> s;
            s.push_back(allEvents[i]);
            unsigned int j = i-1;
            while (!allEvents[j].isStartEvent() && !allEvents[j].isBreakEvent()){
                if (!allEvents[j].isRedundant2() && !allEvents[j].isRedudant() && !allEvents[j].isGKEvent()){
                    s.push_back(allEvents[j]);
                }
                j--;
            }
            if (allEvents[j].isStartEvent()){
                s.push_back(allEvents[j]);
            }
            if (s.size() == 1 && s[0].typeId == 5){
                
            }else{
                sortEventVector(s);
                markov.push_back(s);
            }
        }
    }
}

void Match::findMarkovZones() {
	for (unsigned int i = 0;i < this->markov.size();i++) {
		for (unsigned int j = 0;j < this->markov[i].size();j++) {
			fieldZonePass2(markov[i][j]);
			if (this->markov[i][j].typeId == 1) {
				this->markov[i][j].setEnd();
				fieldZonePassEnd2(this->markov[i][j]);
			}
			else {
				this->markov[i][j].fieldZoneEnd = this->markov[i][j].fieldZone;
			}
		}
	}
}

void Match::markovCarry() {
	for (unsigned int i = 0;i < this->markov.size();i++) {
		unsigned int length = this->markov[i].size();
		unsigned int j = 1;
		while (j < length) {
			if (this->markov[i][j].typeId == 4 && this->markov[i][j].qualExist(10)) { // hands	
				this->markov[i][j].player = this->markov[i][j - 1].player;
			}
			if (this->markov[i][j - 1].typeId == 1 && (this->markov[i][j].isAllPasses() || this->markov[i][j].isShot() || this->markov[i][j].typeId == 4) && (this->markov[i][j - 1].endX != this->markov[i][j].x || this->markov[i][j - 1].endY != this->markov[i][j].y)) {
				Event nytt = this->markov[i][j];
				nytt.typeId = 0;
				nytt.fieldZone = this->markov[i][j-1].fieldZoneEnd;
				nytt.fieldZoneEnd = this->markov[i][j].fieldZone;
				if (this->markov[i][j].typeId == 4 && this->markov[i][j].qualExist(10)) { // hands
					nytt.player = this->markov[i][j - 1].player;
					this->markov[i][j].player = this->markov[i][j - 1].player;
				}
				this->markov[i].push_back(nytt);
			}
			j++;
		}
		sortEventVector(this->markov[i]);
	}
}

void Match::markovTypes() {
	for (unsigned int i = 0;i < this->markov.size();i++) {
		for (unsigned int j = 0;j < this->markov[i].size();j++) {
			this->markov[i][j].markovSeq = i+1;
			this->markov[i][j].markovId = this->markov[i][j].typeId;
            if (this->markov[i][j].isCorner()) {
                this->markov[i][j].markovId = 109;
            }
            else if (this->markov[i][j].isFreeKick()) {
                this->markov[i][j].markovId = 150;
            }
            else if (this->markov[i][j].isCross()) {
                this->markov[i][j].markovId = 102;
            }
            else if (this->markov[i][j].isStartEvent()) { // q=107,123,124,198,199,279
                if (this->markov[i][j].qualExist(279)) { // kick-off
                    this->markov[i][j].markovId = 120;
                }
                else if (this->markov[i][j].qualExist(107)) { // throw-in
                    this->markov[i][j].markovId = 121;
                }
                else {
                    this->markov[i][j].markovId = 122; // GK kick or throw
                }
            }
			else if (this->markov[i][j].isLongPass()) {
				this->markov[i][j].markovId = 105;
			}
            else if (this->markov[i][j].typeId == 17 && (this->markov[i][j].qualExist(32) || this->markov[i][j].qualExist(33) ) ){
                this->markov[i][j].markovId = 118; // red card
            }
		}
	}
}

void Match::markovShotEnd() {
	for (unsigned int i = 0;i < this->markov.size();i++) {
		int l = markov[i].size();
		markov[i][l - 1].markovId = 17;
		Event slutt;
		slutt = markov[i][l-1];
		slutt.markovId = 100;
		markov[i][l - 1].fieldZoneEnd = 32;
		slutt.fieldZone = 32;
		slutt.fieldZoneEnd = 32;
		/*
		if (markov[i][l-1].typeId == 13) {
			markov[i][l - 1].fieldZoneEnd = 32;
			slutt.fieldZone = 32;
			slutt.fieldZoneEnd = 32;
		}
		else if (markov[i][l - 1].typeId == 14) {
			markov[i][l - 1].fieldZoneEnd = 33;
			slutt.fieldZone = 33;
			slutt.fieldZoneEnd = 33;
		}
		else if (markov[i][l - 1].typeId == 15) {
			markov[i][l - 1].fieldZoneEnd = 34;
			slutt.fieldZone = 34;
			slutt.fieldZoneEnd = 34;
		}
		else if (markov[i][l - 1].typeId == 16) {
			markov[i][l - 1].fieldZoneEnd = 35;
			slutt.fieldZone = 35;
			slutt.fieldZoneEnd = 35;
		}
		*/
		markov[i].push_back(slutt);
	}
}

void Match::markovShotEnd2() {
    for (unsigned int i = 0;i < this->markov.size();i++) {
        for (unsigned int j = 0;j<this->markov[i].size();j++){
            if (markov[i][j].markovId == 13 || markov[i][j].markovId == 14 || markov[i][j].markovId == 15 || markov[i][j].markovId == 16 ){
                markov[i][j].markovId = 13;
                Event nytt;
                nytt = markov[i][j];
                nytt.markovId = 100;
                markov[i][j].fieldZoneEnd = 16;
                if (markov[i][j].typeId == 16){
                    nytt.fieldZone = 17;
                    nytt.fieldZoneEnd = 17;
                }else{
                    nytt.fieldZone = 16;
                    nytt.fieldZoneEnd = 16;
                }
                markov[i].push_back(nytt);
            }
        }
        sortEventVector(markov[i]);
    }
}

void Match::markovContext(){
    for (unsigned int i = 0;i < this->markov.size();i++) {
        Event nytt;
        nytt = markov[i][0];
        nytt.markovId = 0;
        nytt.fieldZone = 0;
        nytt.fieldZoneEnd = 0;
        nytt.player = 0;
        nytt.team = 0;
        nytt.typeId = 0;
        //nytt.home = 1;
        nytt.outcome = 1;
        if (nytt.sec == 0 && nytt.min != 0){
            nytt.min--;
        }else if (nytt.sec != 0){
            nytt.sec--;
        }
        markov[i].push_back(nytt);
        sortEventVector(markov[i]);
    }
}

void Match::fixStatusManpower(){
    for (unsigned int i = 0;i < this->markov.size();i++) {
        for (unsigned int j = 0;j<this->markov[i].size();j++){
            if (this->markov[i][j].home == 0 && this->markov[i][j].status != 0){
                this->markov[i][j].status = -this->markov[i][j].status;
            }
            if (this->markov[i][j].home == 0 && this->markov[i][j].manpower != 0){
                this->markov[i][j].manpower = -this->markov[i][j].manpower;
            }
            if (this->markov[i][j].markovId == 0){
                this->markov[i][j].home = 1;
            }
        }
    }
}

void Match::carryEvents(){
    for (unsigned int i = 0;i < this->markov.size();i++) {
        int j = 1;
        int length = this->markov[i].size();
        while (j<length){
            if (this->markov[i][j-1].team == this->markov[i][j].team){
                if ( (this->markov[i][j - 1].typeId == 1 || this->markov[i][j - 1].typeId == 49) && this->markov[i][j-1].markovId != 0 && (this->markov[i][j].isAllPasses() || this->markov[i][j].isShot() || this->markov[i][j].typeId == 4) && (this->markov[i][j - 1].fieldZoneEnd != this->markov[i][j].fieldZone)) {
                    Event nytt = this->markov[i][j];
                    nytt.markovId = 130;
                    nytt.typeId = 0;
                    nytt.fieldZone = this->markov[i][j-1].fieldZoneEnd;
                    nytt.fieldZoneEnd = this->markov[i][j].fieldZone;
                    this->markov[i].push_back(nytt);
                }
            }
            j++;
        }
        sortEventVector(this->markov[i]);
    }

}





























