#pragma once
#include "stdafx.h"
#include "Event.h"

using namespace std;

class Match {

public:
	Match();
	Match(int id, int home, int away, int runde);
	int id;
	int home;
	int away;
	int round;
	int season;
	int kunstgress;
	int KGfordel;
	int NGfordel;
	int eloDiff;

	
	std::vector<Event> eventsH;
	std::vector<Event> eventsA;
	std::vector<Event> allEvents;

	std::vector<Event>* goalSequences;
	string* goalSequencesType;

	vector<vector<Event>> markov;
	void createMarkovSequences();
	void createMarkovSequences2(); // finner skudd-sekvenser
    void createSequences(); // lager alle sekvenser
	void setTimePeriods(); // finds the time periods
	void findMarkovZones();
	void createManpower();
	void markovCarry();
	void markovTypes();
	void markovShotEnd();
    void markovShotEnd2();
    void markovContext();
    void fixStatusManpower(); // endrer til å se fra hjemmelagets perspektiv hele tiden
    void carryEvents();

	int countPasses(int flag, int succ);
	void sortEvents();

	int goals;
	int goalsH;
	int goalsA;
	int logH;
	int logA;
	std::vector<Event> goalEvents;
	std::vector<int> homeStatus;
	std::vector<int> awayStatus;

	void createStatus();
	Event findLast(int period);
	Event findFirst(int period);
	double timeBetween(Event& start, Event& end);

	void findGoalSequences();
	void categorizeGoals();
	void countGoalsAndLog();
	//bool statusCheck(int s, int team);
	Event findAssistEvent(Event& e);
	void getCarryInfo(Event& skudd, Event& assist);
	void getCarryInfo(Event& skudd);
	~Match();

	double statusLengths[3];
	void calcLengths();

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	// ting som skal brukes til utvidelsen av prosjektoppgaven
	int crosses[6];
	double passAcc[6];
	double shareFor[6];
	double shareLong[6];
	int shotsTarget[6];
	double tackWon[6];
	int yellow[6];
	int ballRec[6];
	int fastBreak[6];
	int penArea[6];
	double possession[6];
	void countStatusStats();
	

};
