#include "stdafx.h"
#include "functions.h"
#include "Match.h"
#include "Event.h"
#include "tinyxml2.h"

using namespace tinyxml2;

#ifndef XMLCheckResult
#define XMLCheckResult(a_eResult) if (a_eResult != XML_SUCCESS) { printf("Error: %i\n", a_eResult); return a_eResult; }
#endif

void createSeasonFile() {
	XMLDocument ut;
    // 2016: f24-90-2016-839 + id fra 540-643
	// 2015: f24-90-2015-788 + id fra 219-458
	// 2014: f24-90-2014-739 + id fra 399-638
	XMLDocument doc;
	doc.LoadFile("f24-90-2014-739399-eventdetails.xml");
	XMLNode * pEl = doc.LastChildElement("Games");
	XMLNode * copy = pEl->ShallowClone(&ut);
	ut.InsertFirstChild(copy);
	XMLNode * pEl2 = pEl->FirstChildElement("Game");
	XMLNode * pUt2 = pEl2->ShallowClone(&ut);
	XMLNode * pUt = ut.LastChildElement("Games");
	pUt->InsertEndChild(pUt2);

	for (const XMLNode* node = pEl2->FirstChild(); node; node = node->NextSibling()) {
		XMLNode* copy = node->ShallowClone(&ut);

		for (const XMLNode* q = node->FirstChild(); q; q = q->NextSibling()) {
			XMLNode* qCopy = q->ShallowClone(&ut);
			copy->InsertEndChild(qCopy);
		}
		pUt2->InsertEndChild(copy);
	}
	for (int nr = 400;nr < 639;nr++) {
		using namespace std;
		string name = "f24-90-2014-739";
		string tall = to_string(nr);
		name.append(tall);
		name.append("-eventdetails.xml");
		const char * filnavn = name.c_str();
		XMLDocument doc;
		doc.LoadFile(filnavn);
		XMLNode * pEl = doc.LastChildElement("Games");
		XMLNode * pEl2 = pEl->FirstChildElement("Game");
		XMLNode * pUt2 = pEl2->ShallowClone(&ut);
		XMLNode * pUt = ut.LastChildElement("Games");
		pUt->InsertEndChild(pUt2);

		for (const XMLNode* node = pEl2->FirstChild(); node; node = node->NextSibling()) {
			XMLNode* copy = node->ShallowClone(&ut);

			for (const XMLNode* q = node->FirstChild(); q; q = q->NextSibling()) {
				XMLNode* qCopy = q->ShallowClone(&ut);
				copy->InsertEndChild(qCopy);
			}
			pUt2->InsertEndChild(copy);
		}
	}

	ut.SaveFile("All2014.xml");
}

vector<Match> createVector(int ar) {
	vector<Match> out;
	string name = "All";
	string tall = to_string(ar);
	name.append(tall);
	const char * filnavn = name.c_str();
	name.append(".xml");
	XMLDocument doc, ut;
	doc.LoadFile(filnavn);
	XMLNode * pEl = doc.FirstChildElement("Games");
	for (const XMLElement* pEl2 = pEl->FirstChildElement("Game"); pEl2; pEl2 = pEl2->NextSiblingElement("Game")) {
		Match kamp;
		kamp.id = pEl2->IntAttribute("id");
		kamp.home = pEl2->IntAttribute("home_team_id");
		kamp.away = pEl2->IntAttribute("away_team_id");
		kamp.round = pEl2->IntAttribute("matchday");
		kamp.season = pEl2->IntAttribute("season_id");

		for (const XMLElement* pEl3 = pEl2->FirstChildElement("Event"); pEl3; pEl3 = pEl3->NextSiblingElement("Event")) {
			Event event;
			XMLError e = pEl3->QueryIntAttribute("event_id", &event.nrId);
			e = pEl3->QueryIntAttribute("type_id", &event.typeId);
			e = pEl3->QueryIntAttribute("team_id", &event.team);
			e = pEl3->QueryDoubleAttribute("x", &event.x);
			e = pEl3->QueryDoubleAttribute("y", &event.y);
			e = pEl3->QueryIntAttribute("period_id", &event.half);
			e = pEl3->QueryIntAttribute("min", &event.min);
			e = pEl3->QueryDoubleAttribute("sec", &event.sec);
			e = pEl3->QueryIntAttribute("player_id", &event.player);
			e = pEl3->QueryIntAttribute("outcome", &event.outcome);
			e = pEl3->QueryIntAttribute("id", &event.id);
			e = pEl2->QueryIntAttribute("id", &event.match);
			event.status = 0;

			const XMLElement * q = pEl3->FirstChildElement("Q");

			if (event.half != 16 && q != nullptr) {
				int qId;
				double value;
				XMLError eResult2 = q->QueryIntAttribute("qualifier_id", &qId);
				if (qId != 56 && qId != 127 && qId != 280) {
					event.qId.push_back(qId);
					value = 1;
					if (qId != 279) {
						eResult2 = q->QueryDoubleAttribute("value", &value);
					}
					event.values.push_back(value);
				}
				else {
					int qId = 0;
					double value = 0;
					event.qId.push_back(qId);
					event.values.push_back(value);
				}
				while ((q = q->NextSiblingElement("Q"))) {
					eResult2 = q->QueryIntAttribute("qualifier_id", &qId);
					if (qId != 56 && qId != 127 && qId != 280) {
						event.qId.push_back(qId);
						value = 1;
						if (qId != 279) {
							eResult2 = q->QueryDoubleAttribute("value", &value);
						}
						event.values.push_back(value);
					}
					else {
						int qId = 0;
						double value = 0;
						event.qId.push_back(qId);
						event.values.push_back(value);
					}
				}
			}
			else {
				int qId = 0;
				double value = 0;
				event.qId.push_back(qId);
				event.values.push_back(value);
			}
			
			if (event.team == kamp.home) {
				kamp.eventsH.push_back(event);
                kamp.allEvents.push_back(event);
			}
			else if (event.team == kamp.away){
				kamp.eventsA.push_back(event);
                kamp.allEvents.push_back(event);
			}


		}
		out.push_back(kamp);
	}
	return out;
}

bool qualExist(Event event, int id){
    bool ut = false;
    for (unsigned int i = 0;i < event.qId.size();i++) {
        if (event.qId[i] == id) {
            ut = true;
            break;
        }
    }
    return ut;
}

	string playingPattern(Event& event) {
		string ut;
		if (qualExist(event, 22)) {
			ut = "Regular play";
		}
		else if (qualExist(event,23)) {
			ut = "Fast break";
		}
		else if (qualExist(event, 24)) {
			ut = "Set piece";
		}
		else if (qualExist(event, 25)) {
			ut = "From corner";
		}
		else if (qualExist(event, 26)) {
			ut = "Free kick";
		}
		else if (qualExist(event, 9)) {
			ut = "Penalty";
		}
		else if (qualExist(event, 28)) {
			ut = "Own goal";
		}
		else if (qualExist(event, 160)) {
			ut = "Throw-in set piece";
		}
		return ut;
	}

	string assist(Event& mal, Event& assist) { 
		string ut;
		if (qualExist(assist, 2)) {
			ut = "Cross";
		}
		else if (qualExist(assist, 1) && !qualExist(assist,2)) {
			ut = "Long ball";
		}
		else if (qualExist(assist, 4)) {
			ut = "Through ball";
		}
		else if (qualExist(assist, 3)) {
			ut = "Head pass";
		}
		else if (assist.typeId == 13 && qualExist(assist, 153)) {
			ut = "Shot";
		}
		else if (assist.typeId == 50) {
			ut = "Dispossessed";
		}
		else if (assist.typeId == 15) {
			ut = "Rebound";
		}
		else {
			ut = "Pass";
		}
		return ut;
	}


	string goalLocation(Event& mal) {
		string ut;
		if (qualExist(mal, 16)) {
			ut = "Small box-centre";
		}
		else if (qualExist(mal, 17)) {
			ut = "Box-centre";
		}
		else if (qualExist(mal, 18)) {
			ut = "Out of box-centre";
		}
		else if (qualExist(mal, 19)) {
			ut = "35+ centre";
		}
		else if (qualExist(mal, 60)) {
			ut = "Small box-right";
		}
		else if (qualExist(mal, 61)) {
			ut = "Small box-left";
		}
		else if (qualExist(mal, 62)) {
			ut = "Box-deep right";
		}
		else if (qualExist(mal, 63)) {
			ut = "Box-right";
		}
		else if (qualExist(mal, 64)) {
			ut = "Box-left";
		}
		else if (qualExist(mal, 65)) {
			ut = "Box-deep left";
		}
		else if (qualExist(mal, 66)) {
			ut = "Out of box-deep right";
		}
		else if (qualExist(mal, 67)) {
			ut = "Out of box-right";
		}
		else if (qualExist(mal, 68)) {
			ut = "Out of box-left";
		}
		else if (qualExist(mal, 69)) {
			ut = "Out of box-deep left";
		}
		else if (qualExist(mal, 70)) {
			ut = "35+ right";
		}
		else if (qualExist(mal, 71)) {
			ut = "35+ left";
		}
		return ut;
	}


	void findAllShots(vector<Match> kamper) {
		string fil = "SKUDD2015.csv";
		ofstream ut;
		ut.open(fil);
		// pnet filen

		vector<Event> skudd;
		vector<int> assistType;
		
		for (unsigned int k = 0;k < kamper.size();k++) { // looper gjennom alle kamper
			for (unsigned int i = 0;i < kamper[k].eventsH.size();i++) { // looper gjennom alle hjemmelagets hendelser
				if (kamper[k].eventsH[i].isShot() || kamper[k].eventsH[i].typeId == 60) { // hvis hendelsen er et skudd eller er en stor sjanse
					kamper[k].eventsH[i].calculateLengthAndAngle();
					kamper[k].eventsH[i].findFieldZone();
					int t = 0;
					if (kamper[k].eventsH[i].qualExist(29)) { // hvis sjansen har en assist
                        Event assistEvent = kamper[k].findAssistEvent(kamper[k].eventsH[i]);
						kamper[k].eventsH[i].ass = assist(kamper[k].eventsH[i], assistEvent); // hva slags assist
						t = kamper[k].findAssistEvent(kamper[k].eventsH[i]).typeId;
						if (kamper[k].findAssistEvent(kamper[k].eventsH[i]).typeId == 7 || kamper[k].findAssistEvent(kamper[k].eventsH[i]).typeId == 8 || kamper[k].findAssistEvent(kamper[k].eventsH[i]).typeId == 61 || kamper[k].findAssistEvent(kamper[k].eventsH[i]).typeId == 74) {
							// hvis disse, unintentional assist, LOC = 0 hvis ikke spilleren har gjort en ball recovery imellom
							kamper[k].eventsH[i].ass = "Unintentional";
							kamper[k].getCarryInfo(kamper[k].eventsH[i]); // lengde p ballfring og number of dribbles
						}
						else if (kamper[k].findAssistEvent(kamper[k].eventsH[i]).typeId == 4) {
							kamper[k].eventsH[i].ass = "None";
							kamper[k].getCarryInfo(kamper[k].eventsH[i]); // lengde p ballfring og number of dribbles
						}
						else {
							kamper[k].getCarryInfo(kamper[k].eventsH[i], assistEvent); // lengde p ballfring og number of dribbles
						}
						
					}
					else { // de som ikke har assist
						kamper[k].eventsH[i].assistId = 0;
						kamper[k].getCarryInfo(kamper[k].eventsH[i]); // lengde p ballfring og number of dribbles
						if (kamper[k].eventsH[i - 1].typeId == 15) {
							kamper[k].eventsH[i].ass = "Rebound";	// skuddet var en retur
						}
						else {
							kamper[k].eventsH[i].ass = "None"; // ingen asiist
						}
					}
					kamper[k].eventsH[i].playType = playingPattern(kamper[k].eventsH[i]); // finner "type of play"
					skudd.push_back(kamper[k].eventsH[i]);
					assistType.push_back(t);
				}
			}
			for (unsigned int i = 0;i < kamper[k].eventsA.size();i++) {
				if (kamper[k].eventsA[i].isShot() || kamper[k].eventsA[i].typeId == 60) {
					kamper[k].eventsA[i].calculateLengthAndAngle();
					kamper[k].eventsA[i].findFieldZone();
					int t = 0;
					if (kamper[k].eventsA[i].qualExist(29)) {
                        Event assistEvent = kamper[k].findAssistEvent(kamper[k].eventsA[i]);
						kamper[k].eventsA[i].ass = assist(kamper[k].eventsA[i], assistEvent); // hva slags assist
						t = kamper[k].findAssistEvent(kamper[k].eventsA[i]).typeId;
						if (kamper[k].findAssistEvent(kamper[k].eventsA[i]).typeId == 7 || kamper[k].findAssistEvent(kamper[k].eventsA[i]).typeId == 8 || kamper[k].findAssistEvent(kamper[k].eventsA[i]).typeId == 61 || kamper[k].findAssistEvent(kamper[k].eventsA[i]).typeId == 74) {
							// hvis disse, unintentional assist, LOC = 0 hvis ikke spilleren har gjort en ball recovery imellom
							kamper[k].eventsA[i].ass = "Unintentional";
							kamper[k].getCarryInfo(kamper[k].eventsA[i]); // lengde p ballfring og number of dribbles
						}
						else if (kamper[k].findAssistEvent(kamper[k].eventsA[i]).typeId == 4) {
							kamper[k].eventsA[i].ass = "None";
							kamper[k].getCarryInfo(kamper[k].eventsA[i]); // lengde p ballfring og number of dribbles
						}
						else {
							kamper[k].getCarryInfo(kamper[k].eventsA[i], assistEvent); // lengde p ballfring og number of dribbles
						}
					}
					else {
						kamper[k].eventsA[i].assistId = 0;
						kamper[k].getCarryInfo(kamper[k].eventsA[i]);
						if (kamper[k].eventsA[i - 1].typeId == 15) {
							kamper[k].eventsA[i].ass = "Rebound";	
						}
						else {
							kamper[k].eventsA[i].ass = "None";
						}
						
					}
					kamper[k].eventsA[i].playType = playingPattern(kamper[k].eventsA[i]);
					skudd.push_back(kamper[k].eventsA[i]);
					assistType.push_back(t);
				}
			}
		}


		// skriver ut til fil
		ut << "Match id, " << "Player id, " << "Min, " << "Sec, " << "x, " << "y, " << "Length, " << "Angle, " << "Goal?, " << "Free kick?, " << "Penalty?, " << "Assist, " << "Type of play, " << "Length of carry, " << "Number of dribbles, " << "Header?, " << "Other body part?, " << "Assist event nr," << "Assist type, " << "FieldZone, " << "\n";
		for (unsigned int i = 0;i < skudd.size();i++) {
			int maal = 0;
			if (skudd[i].typeId == 16 && skudd[i].outcome == 1) {
				maal = 1;
			}
			ut << skudd[i].match << ", " << skudd[i].player << ", " << skudd[i].min << ", " << skudd[i].sec << ", " << skudd[i].x << ", " << skudd[i].y << ", "  << skudd[i].lengthToGoal << ", " << skudd[i].angleToGoal << ", " << maal << ", " << qualExist(skudd[i], 26) << ", " << qualExist(skudd[i], 9) << ", " << skudd[i].ass << ", " << skudd[i].playType << ", " << skudd[i].carryLength << ", " << skudd[i].numberOfDribbles << ", "<< skudd[i].qualExist(15) << ", " << skudd[i].qualExist(21) << ", " << skudd[i].assistId << ", " << assistType[i] << ", " << skudd[i].fieldZone << "\n";
		}
	}

	void fieldZonePass(Event& pass) {
		if (pass.x >= 94.2 && pass.x <= 100 && pass.y >= 44.2 && pass.y <= 55.8) {
			pass.fieldZone = 1;
		}
		else if (pass.x >= 94.2 && pass.x <= 100 && pass.y > 55.8 && pass.y <= 63.2) {
			pass.fieldZone = 2;
		}
		else if (pass.x >= 94.2 && pass.x <= 100 && pass.y >= 36.8 && pass.y < 44.2) {
			pass.fieldZone = 3;
		}
		else if (pass.x >= 83 && pass.x < 94.2 && pass.y >= 36.8 && pass.y <= 63.2) {
			pass.fieldZone = 4;
		}
		else if (pass.x >= 83 && pass.x < 94.2 && pass.y > 63.2 && pass.y <= 78.9) {
			pass.fieldZone = 5;
		}
		else if (pass.x >= 83 && pass.x < 94.2 && pass.y >= 21.1 && pass.y < 36.8) {
			pass.fieldZone = 6;
		}
		else if (pass.x >= 94.2 && pass.x <= 100 && pass.y > 63.2 && pass.y <= 78.9) {
			pass.fieldZone = 7;
		}
		else if (pass.x >= 94.2 && pass.x <= 100 && pass.y >= 21.1 && pass.y < 36.8) {
			pass.fieldZone = 8;
		}
		else if (pass.x >= 74.9 && pass.x < 83 && pass.y >= 50 && pass.y <= 78.9) {
			pass.fieldZone = 9;
		}
		else if (pass.x >= 74.9 && pass.x < 83 && pass.y >= 21.1 && pass.y < 50) {
			pass.fieldZone = 10;
		}
		else if (pass.x >= 66.6 && pass.x < 74.9 && pass.y >= 50 && pass.y <= 78.9) {
			pass.fieldZone = 11;
		}
		else if (pass.x >= 66.6 && pass.x < 74.9 && pass.y >= 21.1 && pass.y < 50) {
			pass.fieldZone = 12;
		}
		else if (pass.x >= 58.3 && pass.x < 66.6 && pass.y >= 50 && pass.y <= 78.9) {
			pass.fieldZone = 13;
		}
		else if (pass.x >= 58.3 && pass.x < 66.6 && pass.y >= 21.1 && pass.y < 50) {
			pass.fieldZone = 14;
		}
		else if (pass.x >= 50 && pass.x < 58.3 && pass.y >= 50 && pass.y <= 78.9) {
			pass.fieldZone = 15;
		}
		else if (pass.x >= 50 && pass.x < 58.3 && pass.y >= 21.1 && pass.y < 50) {
			pass.fieldZone = 16;
		}
		else if (pass.x >= 87.5 && pass.x <= 100 && pass.y > 78.9 && pass.y <= 89.5) {
			pass.fieldZone = 17;
		}
		else if (pass.x >= 87.5 && pass.x <= 100 && pass.y >= 10.6 && pass.y < 21.1) {
			pass.fieldZone = 18;
		}
		else if (pass.x >= 87.5 && pass.x <= 100 && pass.y > 89.5 && pass.y <= 100) {
			pass.fieldZone = 19;
		}
		else if (pass.x >= 87.5 && pass.x <= 100 && pass.y >= 0 && pass.y < 10.6) {
			pass.fieldZone = 20;
		}
		else if (pass.x >= 74.9 && pass.x < 87.5 && pass.y > 78.9 && pass.y <= 89.5) {
			pass.fieldZone = 21;
		}
		else if (pass.x >= 74.9 && pass.x < 87.5 && pass.y >= 10.6 && pass.y < 21.1) {
			pass.fieldZone = 22;
		}
		else if (pass.x >= 74.9 && pass.x < 87.5 && pass.y > 89.5 && pass.y <= 100) {
			pass.fieldZone = 23;
		}
		else if (pass.x >= 74.9 && pass.x < 87.5 && pass.y >= 0 && pass.y <= 10.6) {
			pass.fieldZone = 24;
		}
		else if (pass.x >= 50 && pass.x < 74.9 && pass.y > 78.9 && pass.y <= 89.5) {
			pass.fieldZone = 25;
		}
		else if (pass.x >= 50 && pass.x < 74.9 && pass.y >= 10.6 && pass.y < 21.1) {
			pass.fieldZone = 26;
		}
		else if (pass.x >= 50 && pass.x < 74.9 && pass.y > 89.5 && pass.y <= 100) {
			pass.fieldZone = 27;
		}
		else if (pass.x >= 50 && pass.x < 74.9 && pass.y >= 0 && pass.y < 10.6) {
			pass.fieldZone = 28;
		}
		else if (pass.x >= 0 && pass.x < 16.7 && pass.y >= 0 && pass.y <= 100) {
			pass.fieldZone = 31;
		}
		else if (pass.x >= 16.7 && pass.x < 33.3 && pass.y >= 0 && pass.y <= 100) {
			pass.fieldZone = 30;
		}
		else if (pass.x >= 33.3 && pass.x < 50 && pass.y >= 0 && pass.y <= 100) {
			pass.fieldZone = 29;
		}
	}

void fieldZonePass2(Event& pass) {
    if (pass.x >= 0 && pass.x < 16.7 && pass.y >= 0 && pass.y <= 100) { pass.fieldZone = 1;}
    else if (pass.x >= 16.7 && pass.x < 33.3 && pass.y >= 0 && pass.y <= 100) {pass.fieldZone = 2;}
    else if (pass.x >= 33.3 && pass.x < 50 && pass.y >= 0 && pass.y <= 100) {pass.fieldZone = 3;}
    else if (pass.x >= 50 && pass.x < 66.7 && pass.y >= 0 && pass.y <= 25) {pass.fieldZone = 4;}
    else if (pass.x >= 50 && pass.x < 66.7 && pass.y >= 25 && pass.y <= 50) {pass.fieldZone = 5;}
    else if (pass.x >= 50 && pass.x < 66.7 && pass.y >= 50 && pass.y <= 75) {pass.fieldZone = 6;}
    else if (pass.x >= 50 && pass.x < 66.7 && pass.y >= 75 && pass.y <= 100) {pass.fieldZone = 7;}
    else if (pass.x >= 66.7 && pass.x < 83.3 && pass.y >= 0 && pass.y <= 25) {pass.fieldZone = 8;}
    else if (pass.x >= 66.7 && pass.x < 83.3 && pass.y >= 25 && pass.y <= 50) {pass.fieldZone = 9;}
    else if (pass.x >= 66.7 && pass.x < 83.3 && pass.y >= 50 && pass.y <= 75) {pass.fieldZone = 10;}
    else if (pass.x >= 66.7 && pass.x < 83.3 && pass.y >= 75 && pass.y <= 100) {pass.fieldZone = 11;}
    else if (pass.x >= 83.3 && pass.x <= 100 && pass.y >= 0 && pass.y <= 25) {pass.fieldZone = 12;}
    else if (pass.x >= 83.3 && pass.x <= 100 && pass.y >= 25 && pass.y <= 50) {pass.fieldZone = 13;}
    else if (pass.x >= 83.3 && pass.x <= 100 && pass.y >= 50 && pass.y <= 75) {pass.fieldZone = 14;}
    else if (pass.x >= 83.3 && pass.x <= 100 && pass.y >= 75 && pass.y <= 100) {pass.fieldZone = 15;}
}

void fieldZonePassEnd2(Event& pass) {
    if (pass.endX>= 0 && pass.endX< 16.7 && pass.endY >= 0 && pass.endY <= 100) { pass.fieldZoneEnd = 1;}
    else if (pass.endX>= 16.7 && pass.endX< 33.3 && pass.endY >= 0 && pass.endY <= 100) {pass.fieldZoneEnd = 2;}
    else if (pass.endX>= 33.3 && pass.endX< 50 && pass.endY >= 0 && pass.endY <= 100) {pass.fieldZoneEnd = 3;}
    else if (pass.endX>= 50 && pass.endX< 66.7 && pass.endY >= 0 && pass.endY <= 25) {pass.fieldZoneEnd = 4;}
    else if (pass.endX>= 50 && pass.endX< 66.7 && pass.endY >= 25 && pass.endY <= 50) {pass.fieldZoneEnd = 5;}
    else if (pass.endX>= 50 && pass.endX< 66.7 && pass.endY >= 50 && pass.endY <= 75) {pass.fieldZoneEnd = 6;}
    else if (pass.endX>= 50 && pass.endX< 66.7 && pass.endY >= 75 && pass.endY <= 100) {pass.fieldZoneEnd = 7;}
    else if (pass.endX>= 66.7 && pass.endX< 83.3 && pass.endY >= 0 && pass.endY <= 25) {pass.fieldZoneEnd = 8;}
    else if (pass.endX>= 66.7 && pass.endX< 83.3 && pass.endY >= 25 && pass.endY <= 50) {pass.fieldZoneEnd = 9;}
    else if (pass.endX>= 66.7 && pass.endX< 83.3 && pass.endY >= 50 && pass.endY <= 75) {pass.fieldZoneEnd = 10;}
    else if (pass.endX>= 66.7 && pass.endX< 83.3 && pass.endY >= 75 && pass.endY <= 100) {pass.fieldZoneEnd = 11;}
    else if (pass.endX>= 83.3 && pass.endX<= 100 && pass.endY >= 0 && pass.endY <= 25) {pass.fieldZoneEnd = 12;}
    else if (pass.endX>= 83.3 && pass.endX<= 100 && pass.endY >= 25 && pass.endY <= 50) {pass.fieldZoneEnd = 13;}
    else if (pass.endX>= 83.3 && pass.endX<= 100 && pass.endY >= 50 && pass.endY <= 75) {pass.fieldZoneEnd = 14;}
    else if (pass.endX>= 83.3 && pass.endX<= 100 && pass.endY >= 75 && pass.endY <= 100) {pass.fieldZoneEnd = 15;}
}

	void fieldZonePassEnd(Event& pass) {
		if (pass.endX >= 94.2 && pass.endX <= 100 && pass.endY >= 44.2 && pass.endY <= 55.8) {
			pass.fieldZoneEnd = 1;
		}
		else if (pass.endX >= 94.2 && pass.endX <= 100 && pass.endY > 55.8 && pass.endY <= 63.2) {
			pass.fieldZoneEnd = 2;
		}
		else if (pass.endX >= 94.2 && pass.endX <= 100 && pass.endY >= 36.8 && pass.endY < 44.2) {
			pass.fieldZoneEnd = 3;
		}
		else if (pass.endX >= 83 && pass.endX < 94.2 && pass.endY >= 36.8 && pass.endY <= 63.2) {
			pass.fieldZoneEnd = 4;
		}
		else if (pass.endX >= 83 && pass.endX < 94.2 && pass.endY > 63.2 && pass.endY <= 78.9) {
			pass.fieldZoneEnd = 5;
		}
		else if (pass.endX >= 83 && pass.endX < 94.2 && pass.endY >= 21.1 && pass.endY < 36.8) {
			pass.fieldZoneEnd = 6;
		}
		else if (pass.endX >= 94.2 && pass.endX <= 100 && pass.endY > 63.2 && pass.endY <= 78.9) {
			pass.fieldZoneEnd = 7;
		}
		else if (pass.endX >= 94.2 && pass.endX <= 100 && pass.endY >= 21.1 && pass.endY < 36.8) {
			pass.fieldZoneEnd = 8;
		}
		else if (pass.endX >= 74.9 && pass.endX < 83 && pass.endY >= 50 && pass.endY <= 78.9) {
			pass.fieldZoneEnd = 9;
		}
		else if (pass.endX >= 74.9 && pass.endX < 83 && pass.endY >= 21.1 && pass.endY < 50) {
			pass.fieldZoneEnd = 10;
		}
		else if (pass.endX >= 66.6 && pass.endX < 74.9 && pass.endY >= 50 && pass.endY <= 78.9) {
			pass.fieldZoneEnd = 11;
		}
		else if (pass.endX >= 66.6 && pass.endX < 74.9 && pass.endY >= 21.1 && pass.endY < 50) {
			pass.fieldZoneEnd = 12;
		}
		else if (pass.endX >= 58.3 && pass.endX < 66.6 && pass.endY >= 50 && pass.endY <= 78.9) {
			pass.fieldZoneEnd = 13;
		}
		else if (pass.endX >= 58.3 && pass.endX < 66.6 && pass.endY >= 21.1 && pass.endY < 50) {
			pass.fieldZoneEnd = 14;
		}
		else if (pass.endX >= 50 && pass.endX < 58.3 && pass.endY >= 50 && pass.endY <= 78.9) {
			pass.fieldZoneEnd = 15;
		}
		else if (pass.endX >= 50 && pass.endX < 58.3 && pass.endY >= 21.1 && pass.endY < 50) {
			pass.fieldZoneEnd = 16;
		}
		else if (pass.endX >= 87.5 && pass.endX <= 100 && pass.endY > 78.9 && pass.endY <= 89.5) {
			pass.fieldZoneEnd = 17;
		}
		else if (pass.endX >= 87.5 && pass.endX <= 100 && pass.endY >= 10.6 && pass.endY < 21.1) {
			pass.fieldZoneEnd = 18;
		}
		else if (pass.endX >= 87.5 && pass.endX <= 100 && pass.endY > 89.5 && pass.endY <= 100) {
			pass.fieldZoneEnd = 19;
		}
		else if (pass.endX >= 87.5 && pass.endX <= 100 && pass.endY >= 0 && pass.endY < 10.6) {
			pass.fieldZoneEnd = 20;
		}
		else if (pass.endX >= 74.9 && pass.endX < 87.5 && pass.endY > 78.9 && pass.endY <= 89.5) {
			pass.fieldZoneEnd = 21;
		}
		else if (pass.endX >= 74.9 && pass.endX < 87.5 && pass.endY >= 10.6 && pass.endY < 21.1) {
			pass.fieldZoneEnd = 22;
		}
		else if (pass.endX >= 74.9 && pass.endX < 87.5 && pass.endY > 89.5 && pass.endY <= 100) {
			pass.fieldZoneEnd = 23;
		}
		else if (pass.endX >= 74.9 && pass.endX < 87.5 && pass.endY >= 0 && pass.endY <= 10.6) {
			pass.fieldZoneEnd = 24;
		}
		else if (pass.endX >= 50 && pass.endX < 74.9 && pass.endY > 78.9 && pass.endY <= 89.5) {
			pass.fieldZoneEnd = 25;
		}
		else if (pass.endX >= 50 && pass.endX < 74.9 && pass.endY >= 10.6 && pass.endY < 21.1) {
			pass.fieldZoneEnd = 26;
		}
		else if (pass.endX >= 50 && pass.endX < 74.9 && pass.endY > 89.5 && pass.endY <= 100) {
			pass.fieldZoneEnd = 27;
		}
		else if (pass.endX >= 50 && pass.endX < 74.9 && pass.endY >= 0 && pass.endY < 10.6) {
			pass.fieldZoneEnd = 28;
		}
		else if (pass.endX >= 0 && pass.endX < 16.7 && pass.endY >= 0 && pass.endY <= 100) {
			pass.fieldZoneEnd = 31;
		}
		else if (pass.endX >= 16.7 && pass.endX < 33.3 && pass.endY >= 0 && pass.endY <= 100) {
			pass.fieldZoneEnd = 30;
		}
		else if (pass.endX >= 33.3 && pass.endX < 50 && pass.endY >= 0 && pass.endY <= 100) {
			pass.fieldZoneEnd = 29;
		}
	}

	void sortEventVector(vector<Event>& v) {
		int length = v.size();
		for (int i = 0;i < length;++i) {
			bool swapped = false;
			for (int j = 0;j < length - (i + 1); ++j) {
				if ((v[j] < v[j + 1]) == false) {
					Event temp = v[j];
					v[j] = v[j + 1];
					v[j + 1] = temp;
					swapped = true;
				}
			}
			if (!swapped) break;
		}

	}

	bool compareEvents(const Event& lhs, const Event& rhs) {
		if (lhs.half != 16 && rhs.half == 16) {
			return false;
		}
		else if (lhs.half == 16 && rhs.half != 16) {
			return true;
		}
		else if (lhs.half != 16 && rhs.half != 16 && lhs.half < rhs.half) {
			return true;
		}
		else if (lhs.half != 16 && rhs.half != 16 && lhs.half > rhs.half) {
			return false;
		}
		else {
			if (lhs.min < rhs.min) {
				return true;
			}
			else if (lhs.min > rhs.min) {
				return false;
			}
			else {
				if (lhs.sec < rhs.sec) {
					return true;
				}
				else if (lhs.sec == rhs.sec) {
					if (rhs.typeId == 5) {
						return true;
					}
					else if (lhs.typeId == 5) {
						return false;
					}
					else {
						return false;
					}
				}
				else {
					return false;
				}
			}
		}
	}


	void makeSquadFile() {
		ofstream ut;
		ut.open("squads2014.csv");
		XMLDocument doc;
		doc.LoadFile("srml-90-2014-squads.xml");
		XMLNode * pEl = doc.LastChildElement("SoccerFeed");
		XMLNode * pEl2 = pEl->FirstChildElement("SoccerDocument");

		ut << "Player,Name,Position,Team id,Team" << "\n";
		for (const XMLElement* node = pEl2->FirstChildElement("Team"); node; node = node->NextSiblingElement("Team")) {
			for (const XMLElement* q = node->FirstChildElement("Player"); q; q = q->NextSiblingElement("Player")) {
				int id, teamId;
				string idS, teamIdS, name1, pos, team;
				//XMLError e = q->QueryAttribute("uID", &id);
				//e = node->QueryAttribute("uID", &teamId);
				idS = q->Attribute("uID");
				teamIdS = node->Attribute("uID");
				string s = idS.substr(1, idS.length());
				string te = teamIdS.substr(1, teamIdS.length());
				id = stoi(s);
				teamId = stoi(te);
				const XMLElement* n = q->FirstChildElement("Name");
				name1 = n->GetText();
				const XMLElement* p = n->NextSiblingElement("Position");
				pos = p->GetText();
				const XMLElement* t = node->FirstChildElement("Name");
				team = t->GetText();
				ut << id << "," << name1 << "," << pos << "," << teamId << "," << team << "\n";
			}
		}
        XMLNode* dritt = pEl2->FirstChildElement("PlayerChanges");
        for (const XMLElement* node = dritt->FirstChildElement("Team"); node; node = node->NextSiblingElement("Team")) {
            for (const XMLElement* q = node->FirstChildElement("Player"); q; q = q->NextSiblingElement("Player")) {
                int id, teamId;
                string idS, teamIdS, name1, pos, team;
                //XMLError e = q->QueryAttribute("uID", &id);
                //e = node->QueryAttribute("uID", &teamId);
                idS = q->Attribute("uID");
                teamIdS = node->Attribute("uID");
                string s = idS.substr(1, idS.length());
                string te = teamIdS.substr(1, teamIdS.length());
                id = stoi(s);
                teamId = stoi(te);
                const XMLElement* n = q->FirstChildElement("Name");
                name1 = n->GetText();
                const XMLElement* p = n->NextSiblingElement("Position");
                pos = p->GetText();
                const XMLElement* t = node->FirstChildElement("Name");
                team = t->GetText();
                ut << id << "," << name1 << "," << pos << "," << teamId << "," << team << "\n";
            }
        }
        XMLElement* node = dritt->LastChildElement("Team");
        XMLElement* q = node->LastChildElement("Player");
        int id, teamId;
        string idS, teamIdS, name1, pos, team;
        //XMLError e = q->QueryAttribute("uID", &id);
        //e = node->QueryAttribute("uID", &teamId);
        idS = q->Attribute("uID");
        teamIdS = node->Attribute("uID");
        string s = idS.substr(1, idS.length());
        string te = teamIdS.substr(1, teamIdS.length());
        id = stoi(s);
        teamId = stoi(te);
        const XMLElement* n = q->FirstChildElement("Name");
        name1 = n->GetText();
        const XMLElement* p = n->NextSiblingElement("Position");
        pos = p->GetText();
        const XMLElement* t = node->FirstChildElement("Name");
        team = t->GetText();
        ut << id << "," << name1 << "," << pos << "," << teamId << "," << team << "\n";
	}

	void readAllMatches() {

		//createSeasonFile2();

        vector<Match> kamper15;
        kamper15 = createVector(2016);
		//kamper15 = createVector(2015);
        //kamper15 = createVector(2014);

        ofstream ut;
		ut.open("sekvensCarry16.csv");
		ut << "Type,Period,Status,Manpower,FieldZone,FieldZoneEnd,Team,Player,Match,Sequence,Outcome,Goal,Owngoal,Home" << "\n";
		for (unsigned int k = 0;k < kamper15.size();k++) {
			kamper15[k].sortEvents();
			kamper15[k].createStatus();
			kamper15[k].createManpower();
			kamper15[k].setTimePeriods();
			kamper15[k].createSequences(); // finner alle sekvenser
			kamper15[k].findMarkovZones(); // denne m etter markovsequences! setter ogs sluttkoordinater p de som har
            kamper15[k].markovTypes(); // setter markovtype id'er (dvs innlegg o.l. fr egen), og sekvensnummer
			kamper15[k].markovShotEnd2(); // legger p et ekstra event etter skuddet
            kamper15[k].markovContext(); // legger p et kontext-event frst i hver sekvens
            kamper15[k].fixStatusManpower(); // fikser slik at status/manpower sees fra hjemmelaget uansett
            kamper15[k].carryEvents(); // lager carry-events
            
            
			for (unsigned int i = 0;i < kamper15[k].markov.size();i++) {
				for (unsigned int j = 0;j<kamper15[k].markov[i].size();j++) {
					int mal = 0;
                    int selv = 0;
					if (kamper15[k].markov[i][j].typeId == 16 && !kamper15[k].markov[i][j].qualExist(28)) { mal = 1; }
                    if (kamper15[k].markov[i][j].typeId == 16 && kamper15[k].markov[i][j].qualExist(28)) { selv = 1; }
					ut << kamper15[k].markov[i][j].markovId << "," << kamper15[k].markov[i][j].markovPeriod << "," << kamper15[k].markov[i][j].status << "," << kamper15[k].markov[i][j].manpower << "," << kamper15[k].markov[i][j].fieldZone << "," << kamper15[k].markov[i][j].fieldZoneEnd << "," << kamper15[k].markov[i][j].team << "," << kamper15[k].markov[i][j].player << "," << kamper15[k].markov[i][j].match << "," << kamper15[k].markov[i][j].markovSeq << "," << kamper15[k].markov[i][j].outcome << "," << mal << "," << selv << "," << kamper15[k].markov[i][j].home << "\n";
				}
			}
		}
	}


// MARKOV UNDER HER

void runModel2(){
    vector<vector<int> > data, data15, data14, data16;
    
    ifstream file("BeggeMedCarryLARGE.txt"); // for gamle: "AltBeggeNyeSonerSTATE.txt"
    string line;
    while (getline(file, line))
    {
        vector<int>   lineData;
        stringstream  lineStream(line);
        int value;
        while (lineStream >> value) {
            lineData.push_back(value);
        }
        data.push_back(lineData);
    }
    
    ifstream file15("2015MedCarryLARGE.txt"); // for gamle: "Alt2015NyeSonerSTATE.txt"
    //string line;
    while (getline(file15, line))
    {
        vector<int>   lineData;
        stringstream  lineStream(line);
        int value;
        while (lineStream >> value) {
            lineData.push_back(value);
        }
        data15.push_back(lineData);
    }
    
    ifstream file14("2014MedCarryLARGE.txt");
    //string line;
    while (getline(file14, line))
    {
        vector<int>   lineData;
        stringstream  lineStream(line);
        int value;
        while (lineStream >> value) {
            lineData.push_back(value);
        }
        data14.push_back(lineData);
    }
    
    ifstream file16("2016MedCarry.txt");
    //string line;
    while (getline(file16, line))
    {
        vector<int>   lineData;
        stringstream  lineStream(line);
        int value;
        while (lineStream >> value) {
            lineData.push_back(value);
        }
        data16.push_back(lineData);
    }
    
    int numberOfUniqueStates = 34953; // for nr alt er med i en state inkludert 130 og 0
    vector<StateClass> states;
    //states = findAllStates(data); // setter statenummere p alle hendelser og states, og dette kan legges inn i txt filene som brukes i valueiteration
    states = calculateTransitions(data, numberOfUniqueStates);
    valueIteration(states,numberOfUniqueStates,data15); // 2015
    //valueIteration(states,numberOfUniqueStates,data14); // 2014
    
    // skriver ut informasjon om hver state
    ofstream test;
    test.open("VI15LARGE.csv");
    
    test << "Type,Period,Status,Manpower,Zone,ZoneEnd,Home,Outcome,Goal,StateId,Occurrences,Value,Reward" << "\n";
    for (int i = 0;i<states.size();i++){
        test << states[i].type << "," << states[i].period << "," << states[i].status << "," << states[i].manpower << "," << states[i].zone << "," << states[i].zoneEnd << "," << states[i].home << "," << states[i].outcome << "," << states[i].goal << "," << states[i].stateId << "," << states[i].occ << "," << states[i].value << "," << states[i].reward << "\n";
    }
}

int stateExist(vector<StateClass> v, StateClass s){
    int ut = -1;
    for (int i = 0;i<v.size();i++){
        if (v[i] == s){
            ut = i;
            break;
        }
    }
    return ut;
}

vector<StateClass> findAllStates(vector<vector<int>>& data){
    vector<StateClass> ut;
    ofstream idUt;
    idUt.open("ider.csv");
    int ids[760765]; // 760765 med bde carry og kontekst, totalt for 2014 og 2015
    int id = 0;
    for (int i = 0;i<data.size();i++){
        StateClass s;
        s.type = data[i][0];
        s.period = data[i][1];
        s.home = data[i][13];
        s.status = data[i][2];
        s.manpower = data[i][3];
        if (s.type == 120){
            s.zone = 3;
            s.zoneEnd = 3;
            data[i][4] = 3;
            data[i][5] = 3;
        }else{
            s.zone = data[i][4];
            s.zoneEnd = data[i][5];
        }
        s.outcome = data[i][10];
        if (s.type == 100){
            s.goal = data[i][11] - data[i][12];
        }else{
            s.goal = 0;
        }
        
        int plass = stateExist(ut,s);
        if (plass == -1){ // eksisterer ikke i vektoren ut
            s.occ = 1;
            s.stateId = id;
            ids[i] = id;
            id++;
            ut.push_back(s);
        }else{ // eksisterer i vektoren ut
            ut[plass].occ++;
            s.stateId = ut[plass].stateId;
            ids[i] = s.stateId;
        }
        data[i].push_back(ids[i]);
        idUt << ids[i] << "\n";
    }
    return ut;
}


vector<StateClass> calculateTransitions(vector<vector<int>> data, int &numberOfUniqueStates){
    vector<StateClass> ut;
    for (int i = 0;i<=numberOfUniqueStates;i++){
        StateClass s;
        s.occ = 0;
        ut.push_back(s); // fyller inn "tomme states"
    }
    for (int i = 0;i<data.size()-1;i++){
        StateClass s;
        s.type = data[i][0];
        s.period = data[i][1];
        s.status = data[i][2];
        s.manpower = data[i][3];
        s.zone = data[i][4];
        s.zoneEnd = data[i][5];
        s.outcome = data[i][10];
        if (s.type == 100){
            s.goal = data[i][11] - data[i][12];
        }else{
            s.goal = 0;
        }
        s.home = data[i][13];
        s.stateId = data[i][14];

        if (((data[i][8] == data[i+1][8]) && (data[i][9] == data[i+1][9]))  ){
            
            StateClass s2;
            s2.type = data[i+1][0];
            s2.period = data[i+1][1];
            s2.status = data[i+1][2];
            s2.manpower = data[i+1][3];
            s2.zone = data[i+1][4];
            s2.zoneEnd = data[i+1][5];
            s2.outcome = data[i+1][10];
            if (s2.type == 100){
                s2.goal = data[i+1][11] - data[i+1][12];
            }else{
                s2.goal = 0;
            }
            s2.home = data[i+1][13];
            s2.stateId = data[i+1][14];

            if (ut[s.stateId].occ == 0){ //plassen er tom
                s.occ = 1;
                s.count[s2] = 1;
                ut[s.stateId] = s;
            }else{ //finnes i vektoren ut
                ut[s.stateId].occ++;
                if (ut[s.stateId].count.count(s2) > 0){ // finnes i map'et
                //if (ut[s.stateId].count.find(s2) != ut[s.stateId].count.end()){ // finnes i map'et
                    ut[s.stateId].count[s2]++;
                    ut[s.stateId].c[s2.stateId]++;
                    
                }else{
                    ut[s.stateId].count[s2] = 1;
                    ut[s.stateId].c[s2.stateId] = 1;
                }
                
            }
        }else{
            if (ut[s.stateId].occ == 0){ // plassen er tom
                s.occ = 1;
                ut[s.stateId] = s;
            }else{ // eksisterer i vektoren ut
                ut[s.stateId].occ++;
            }
        }
    }
    return ut;
}

void valueIteration(vector<StateClass>& states, int& numberOfUniqueStates, vector<vector<int>> data){
    
     for (int i = 0;i<states.size();i++){
         if (states[i].type == 100 && states[i].goal == 1 && states[i].home == 1){ // hjemmelaget scorer
            states[i].value = 1;
             states[i].reward = 1;
         }else if (states[i].type == 100 && states[i].goal == 1 && states[i].home == 0){ // bortelaget scorer
             states[i].value = -1;
             states[i].reward = -1;
         }else if (states[i].type == 100 && states[i].goal == -1 && states[i].home == 0){ // bortelaget scorer selvml -> ml til hjemme
             states[i].value = 1;
             states[i].reward = 1;
        }else if (states[i].type == 100 && states[i].goal == -1 && states[i].home == 1){ // hjemmelaget scorer selvml -> ml til borte
            states[i].value = -1;
            states[i].reward = -1;
        }else{
            states[i].reward = 0;
            states[i].value = 0;
        }
     }
    
    ofstream test;
    test.open("VIConvLARGE.csv");
    
    double lastValue = 0;
    double currentValue = 0;
    bool converged = false;
    double discount = 0.861799;
    double c = 0.000001; // convergence criteria
    int M = 10000; // number of iterations
    for (int n = 0;n<M;n++){ // loops through the iterations
        for (int s = 0;s<states.size();s++){ // loops through the states
            if (converged == false){
                double sum = 0;
                //if (states[s].type != 100){
                    map<StateClass, double>::iterator it;
                    for (it = states[s].count.begin();it != states[s].count.end();it++){
                        int stateid = it->first.stateId;
                        double stateval = states[stateid].value;
                        double occur = it->second;
                        sum = sum + discount*(stateval * occur);
                    }
                //}
                double q = states[s].reward + (sum/states[s].occ);
                states[s].value = q;
                if (q>0){
                    currentValue = currentValue + q;
                }else{
                    currentValue = currentValue - q;
                }
            }
        }
        double conv = ((currentValue-lastValue)/currentValue);
        test << n << "," << currentValue << "," << conv << "\n";
        
        if (converged == false){
            if ( conv < c ){
                converged = true;
                break;
            }
        }
        
        lastValue = currentValue;
        currentValue = 0;
    }
    
    ofstream ut;
    ofstream ode;
    //ode.open("odegaardLarge.csv");
    //ode << "Action,Value" << "\n";
    ut.open("eventvalues15LARGE.csv");
    //ut.open("value14LARGENY.csv");
    
    ut << "Action,Team,Player,Name,Value" << "\n";
    //double valueOfAction[380109]; //FOR 2015 334556 er tallet for 2015 sesongen, noe mindre for 2014, 380109 med alt
    double valueOfAction[380656]; // FOR 2014
    for (int i = 1;i<data.size();i++){
        int stateId = data[i][14];
        //int forrige = data[i-1][14];
        if (data[i][13] == 1 && data[i][0] != 100 && data[i][0] != 0 /*&& (data[i][9] == data[i+1][9]) && data[i][7] == 184029*/){
            valueOfAction[i] = states[stateId].value;
            //ode << data[i][0] << "," << valueOfAction[i] << "\n";
            //valueOfAction[i] = (states[stateId].value - states[forrige].value);
        }else if (data[i][13] == 0 && data[i][0] != 100 && data[i][0] != 0 /*&& data[i][7] == 184029*/){
            valueOfAction[i] = -states[stateId].value;
            //ode << data[i][0] << "," << valueOfAction[i] << "\n";
            //valueOfAction[i] = -(states[stateId].value - states[forrige].value);
        }else{
            valueOfAction[i] = 0;
        }
        ut << data[i][0] << "," << data[i][6] << "," << data[i][7] << "," << " " << "," << valueOfAction[i] << "\n";
        
    }
    
    ofstream ut2;
    ut2.open("15PerMatchLARGE.csv");
    ut2 << "Match,Home,Value,Away,Value" << "\n";
    int matches[240];
    int homeTeams[240], awayTeams[240];
    double matchValues[240];
    for (int kamp = 0;kamp<240;kamp++){
        matches[kamp] = 788219 + kamp; //2015
        //matches[kamp] = 739399 + kamp; // 2014
        int h = 0,a = 0;
        double hVal = 0, aVal = 0;
        for (int i = 0;i<data.size();i++){
            if (data[i][8] == matches[kamp] && data[i][13] == 1){
                hVal = hVal + valueOfAction[i];
                h = data[i][6];
            }else if (data[i][8] == matches[kamp] && data[i][13] == 0){
                aVal = aVal + valueOfAction[i];
                a = data[i][6];
            }
            matchValues[kamp] = hVal - aVal;
            homeTeams[kamp] = h;
            awayTeams[kamp] = a;
        }
        ut2 << matches[kamp] << "," << h << "," << hVal << "," << a << "," << aVal << "\n";
    }
    ofstream ut3;
    ut3.open("PerTeam15LARGE.csv");
    int teams[] = {197, 203, 278, 305, 307, 310, 311, 312, 1098, 2364, 2744, 2745, 2997, 3199, 3334, 3376}; // lag ider som er med i 2015
    //int teams[] = {197, 203, 278, 303, 305, 307, 311, 312, 1098, 1250, 2364, 2744, 2745, 2997, 3376, 3855}; // lag ider som er med i 2014

    for (int t = 0; t<16;t++){
        vector<double> values;
        for (int i = 0;i<240;i++){
            if (teams[t] == homeTeams[i]){
                values.push_back(matchValues[i]);
            }else if (teams[t] == awayTeams[i]){
                values.push_back(-matchValues[i]);
            }
        }
        ut3 << teams[t] << ",";
        for (int s = 0;s<values.size();s++){
            ut3 << values[s] << ",";
        }
        ut3 << "\n";
    }
}




double findStateValue(int id, vector<StateClass>& states){
    StateClass s = states[id];
    double total = 0;
    double value = 0;
    for (int i = 0;i<states.size();i++){
        StateClass s2 = states[i];
        if ( (s.status == s2.status) && (s.period == s2.period) && (s.manpower == s2.manpower) && (s.home == s2.home) && (s.zone == s2.zone) ){
            value = value + s2.occ*s2.value;
            total = total + s2.occ;
        }
    }
    return value/total;
}

void runModel1(){
    vector<vector<int> > data, data15, data14, data16;
    
    ifstream file("BeggeMedCarry.txt");
    string line;
    while (getline(file, line))
    {
        vector<int>   lineData;
        stringstream  lineStream(line);
        int value;
        while (lineStream >> value) {
            lineData.push_back(value);
        }
        data.push_back(lineData);
    }
    
    ifstream file15("2015MedCarry.txt");
    //string line;
    while (getline(file15, line))
    {
        vector<int>   lineData;
        stringstream  lineStream(line);
        int value;
        while (lineStream >> value) {
            lineData.push_back(value);
        }
        data15.push_back(lineData);
    }
    
    ifstream file14("2014MedCarry.txt");
    //string line;
    while (getline(file14, line))
    {
        vector<int>   lineData;
        stringstream  lineStream(line);
        int value;
        while (lineStream >> value) {
            lineData.push_back(value);
        }
        data14.push_back(lineData);
    }
    
    ifstream file16("2016MedCarry.txt");
    //string line;
    while (getline(file16, line))
    {
        vector<int>   lineData;
        stringstream  lineStream(line);
        int value;
        while (lineStream >> value) {
            lineData.push_back(value);
        }
        data16.push_back(lineData);
    }
    
    int numberOfUniqueStates = 1154; // unike states i Modell 1
    vector<StateClass> states;
    states = findAllStates3(data); // setter statenummere p alle hendelser og states

    
    calculateActionsAndTransitions(data, states);
    actionValueIteration(states, data);
    //setSimple16(states, data16); // Kan brukes til  teste out-of-sample, er ikke brukt mye tid p, tar veldig lang tid
    
    
    // Flgende skriver ut informasjon om hver state:
    ofstream test;
    test.open("VI15.csv");
    
    test << "Period,Status,Manpower,Zone,Home,Goal,StateId,Occurrences,Policy,Value,Reward" << "\n";
    for (int i = 0;i<states.size();i++){
        test << states[i].period << "," << states[i].status << "," << states[i].manpower << "," << states[i].zone << "," <<  states[i].home << "," << states[i].goal << "," << states[i].stateId << "," << states[i].occ << "," << states[i].policy << "," << states[i].value << "," << states[i].reward; //<< "\n";
        map<int, double>::iterator it;
        map<int, map<int, double>>::iterator it2;
        for (it2 = states[i].actionState.begin(); it2 != states[i].actionState.end();it2++){
            for (it = it2->second.begin();it != it2->second.end();it++){
                test << "," << it2->first << "," << it->first << "," << it->second;
            }
        }
        test << "\n";
    }
}


vector<StateClass> findAllStates3(vector<vector<int>>& data){
    vector<StateClass> ut;
    ofstream idUt;
    
    idUt.open("ider.csv");
    int ids[760765]; // 667727 uten ekstra kontekst-event, 705020 med, 760765 med carry og kontekst
    int idtil[760765];
    int id = 0;
    for (int i = 0;i<data.size();i++){
        StateClass s,s2;
        if (i == 0){
            s.period = data[i][1];
            s.status = data[i][2];
            s.manpower = data[i][3];
            s.zone = data[i][4];
            s.home = 0;
            s.goal = 0;
            s2.period = data[i+1][1];
            s2.status = data[i+1][2];
            s2.manpower = data[i+1][3];
            s2.zone = data[i+1][4];
            s2.home = data[i+1][13];
            s2.goal = 0;
            
            int plass = stateExist(ut,s);
            if (plass == -1){ // eksisterer ikke i vektoren ut
                s.occ = 0;
                s.stateId = id;
                ids[i] = id;
                id++;
                ut.push_back(s);
            }else{ // eksisterer i vektoren ut
                //ut[plass].occ++;
                s.stateId = ut[plass].stateId;
                ids[i] = s.stateId;
            }
            
            int plass2 = stateExist(ut,s2);
            if (plass2 == -1){ // eksisterer ikke i vektoren ut
                s2.occ = 0;
                s2.stateId = id;
                idtil[i] = id;
                id++;
                ut.push_back(s2);
            }else{ // eksisterer i vektoren ut
                //ut[plass2].occ++;
                s2.stateId = ut[plass2].stateId;
                idtil[i] = s2.stateId;
            }
            
        }else if (i == data.size()-1){
            ids[i] = idtil[i-1];
            idtil[i] = 0;
        }
        else{
            int nesteType = data[i+1][0];
            if (nesteType == 0){
                s2.home = 0;
            }else{
                s2.home = data[i+1][13];
            }
            s2.period = data[i+1][1];
            s2.status = data[i+1][2];
            s2.manpower = data[i+1][3];
            if (nesteType == 120){ // avspark
                s2.zone = 3;
            }else{
                s2.zone = data[i+1][4];
            }
            if (nesteType == 100){ // skuddutfall
                s2.goal = data[i+1][11] - data[i+1][12];
            }else{
                s2.goal = 0;
            }
            if (nesteType == 2){ // offside pass
                data[i+1][0] = 1; // settes til vanlig pasning med outcome 0
                data[i+1][10] = 0;
            }
            ids[i] = idtil[i-1];
            int plass2 = stateExist(ut,s2);
            if (plass2 == -1){ // eksisterer ikke i vektoren ut
                s2.occ = 0;
                s2.stateId = id;
                idtil[i] = id;
                id++;
                ut.push_back(s2);
            }else{ // eksisterer i vektoren ut
                //ut[plass2].occ++;
                s2.stateId = ut[plass2].stateId;
                idtil[i] = s2.stateId;
            }
        }
        
        idUt << ids[i] << "," << idtil[i]<< "\n";
        if (data[i].size() == 15){
            data[i][14] = ids[i];
            data[i].push_back(idtil[i]);
        }else if (data[i].size() == 14){
            data[i].push_back(ids[i]);
            data[i].push_back(idtil[i]);
        }
    }
    
    return ut;
}

void calculateActionsAndTransitions(vector<vector<int>> data, vector<StateClass>& states){
    for (int i = 0;i<data.size();i++){
        int type = data[i][0];
        int state = data[i][14];
        int stateTo = data[i][15];
        StateClass* s = &states[state];
        s->occ++;
        if (s->c.count(stateTo) > 0){
            s->c[stateTo]++;
        }else{
            s->c[stateTo] = 1;
        }
        if (s->actionCount.count(type) > 0){ // finnes i map'et
            s->actionCount[type]++;
            
        }else{
            s->actionCount[type] = 1;
        }
        if (s->actionState[type].count(stateTo) > 0){
            s->actionState[type][stateTo]++;
        }else{
            s->actionState[type][stateTo] = 1;
        }
    }
}

void actionValueIteration(vector<StateClass>& states, vector<vector<int>> data){
    for (int i = 0;i<states.size();i++){
        if (states[i].zone == 17 && states[i].goal == 1 && states[i].home == 1){ // hjemmelaget scorer
            states[i].value = 0;
            states[i].reward = 1;
        }else if (states[i].zone == 17  && states[i].goal == 1 && states[i].home == 0){ // bortelaget scorer
            states[i].value = 0;
            states[i].reward = -1;
        }else if (states[i].zone == 17  && states[i].goal == -1 && states[i].home == 0){ // bortelaget scorer selvml -> ml til hjemme
            states[i].value = 0;
            states[i].reward = 1;
        }else if (states[i].zone == 17  && states[i].goal == -1 && states[i].home == 1){ // hjemmelaget scorer selvml -> ml til borte
            states[i].value = 0;
            states[i].reward = -1;
        }else{
            states[i].reward = 0;
            states[i].value = 0;
        }
    }
    
    ofstream test;
    test.open("VIConvHelp.csv");
    
    double lastValue = 0;
    double currentValue = 0;
    bool converged = false;
    
    double c = 0.000001; // convergence criteria
    int M = 10000; // number of iterations
    double discount = 1;//0.861799;
    for (int n = 1;n<=M;n++){ // loops through the iterations
        for (int i = 0;i<states.size();i++){ // loops through the states
            if (converged == false){
                double q = 0;
                StateClass* s = &states[i];
                s->policy = -1;
                if (s->zone != 17 && s->zone != 0){
                    map<int, map<int, double>>::iterator it2;
                    map<int, double>::iterator it;
                    
                    for (it2 = s->actionState.begin();it2 != s->actionState.end();it2++){
                        double sum = 0;
                        int action = it2->first;
                        for (it = it2->second.begin();it != it2->second.end();it++){
                            int next = it->first;
                            double stateval = states[next].reward + discount*states[next].value;
                            double occur = it->second;
                            sum = sum + (stateval * occur);
                        }
                        s->actionValue[action] = sum;
                    }
                    it = s->actionCount.begin();
                    auto it3 = s->actionValue.begin();
                    double statesum = 0;
                    while (it != s->actionCount.end()){
                        double tot = it3->second;
                        double occ = it->second;
                        it3->second = tot/occ;
                        statesum = statesum + tot;
                        
                        if (s->home == 1){
                            if (it3->second > q){
                                q = it3->second;
                                s->policy = it3->first;
                            }
                        }else{
                            if (it3->second < q){
                                q = it3->second;
                                s->policy = it3->first;
                            }
                        }
                        
                        if (it3->second>0){
                            currentValue = currentValue + it3->second;
                        }else{
                            currentValue = currentValue - it3->second;
                        }
                        
                        ++it;
                        ++it3;
                    }

                    s->value = statesum/s->occ;
                }
            }
        }
        
        double conv = ((currentValue-lastValue)/currentValue);
        test << n << "," << currentValue << "," << conv << "\n";
        
        if (converged == false){
            if ( conv < c ){
                converged = true;
                break;
            }
        }
        
        lastValue = currentValue;
        currentValue = 0;
    }
    
    // skriver ut verdiene av hver action i hver state, Q(s,a)
    ofstream av;
    av.open("actionValues.csv");
    av << "State,Action,Value" << "\n";
    for (int i = 0;i<states.size();i++){
        int state = states[i].stateId;
        map<int, double>::iterator it;
        for (it = states[i].actionValue.begin();it != states[i].actionValue.end(); it++){
            av << state << "," << it->first << "," << it->second << "\n";
        }
    }
    
    
    // SETTER IMPACT VERDI P HVER HENDELSE:
    double valueOfAction[760765];
    ofstream ut;
    ut.open("eventvaluesM115.csv");
    ut << "Action,State,ToState,Team,Player,Name,Value" << "\n";
    for (int i = 0;i<data.size()-1;i++){
        int action = data[i][0];
        int nextAction = data[i+1][0];
        int home = data[i][13];
        int from = data[i][14];
        int to = data[i][15];
        if (data[i][8] >= 788219 && action != 100 && action != 0 && action != 5){ // 2015
        //if (data[i][8] < 788219 && action != 100 && action != 0 && action != 5 && data[i][7] == 184029){ // 2014
            if (home == 1){
                valueOfAction[i] = (states[to].actionValue[nextAction] + states[to].reward - states[from].actionValue[action]);
            }else{
                valueOfAction[i] = -(states[to].actionValue[nextAction] + states[to].reward - states[from].actionValue[action]);
            }
            ut << action << "," << from << "," << to << "," << data[i][6] << "," << data[i][7] << "," << "" << "," << valueOfAction[i] << "\n";
        }
    }
    
    // skriver ut verdier for hver kamp
    ofstream ut2;
    ut2.open("15PerMatchSimple.csv");
    ut2 << "Match,Home,Value,Away,Value" << "\n";
    int matches[240];
    int homeTeams[240], awayTeams[240];
    double matchValues[240];
    for (int kamp = 0;kamp<240;kamp++){
        matches[kamp] = 788219 + kamp; // 2015
        //matches[kamp] = 739399 + kamp; // 2014
        int h = 0,a = 0;
        double hVal = 0, aVal = 0;
        for (int i = 0;i<data.size();i++){
            if (data[i][8] == matches[kamp] && data[i][13] == 1){
                hVal = hVal + valueOfAction[i];
                h = data[i][6];
            }else if (data[i][8] == matches[kamp] && data[i][13] == 0){
                aVal = aVal + valueOfAction[i];
                a = data[i][6];
            }
            matchValues[kamp] = hVal - aVal;
            homeTeams[kamp] = h;
            awayTeams[kamp] = a;
        }
        ut2 << matches[kamp] << "," << h << "," << hVal << "," << a << "," << aVal << "\n";
    }
    
    // skriver ut verdier for hvert lag
    ofstream ut3;
    ut3.open("15PerTeamSimple.csv");
    int teams[] = {197, 203, 278, 305, 307, 310, 311, 312, 1098, 2364, 2744, 2745, 2997, 3199, 3334, 3376}; //2015
    //int teams[] = {197, 203, 278, 303, 305, 307, 311, 312, 1098, 1250, 2364, 2744, 2745, 2997, 3376, 3855}; // 2014
    for (int t = 0; t<16;t++){
        vector<double> values;
        for (int i = 0;i<240;i++){
            if (teams[t] == homeTeams[i]){
                values.push_back(matchValues[i]);
            }else if (teams[t] == awayTeams[i]){
                values.push_back(-matchValues[i]);
            }
        }
        ut3 << teams[t] << ",";
        for (int s = 0;s<values.size();s++){
            ut3 << values[s] << ",";
        }
        ut3 << "\n";
    }
}

void setSimple16(vector<StateClass> states, vector<vector<int>>& data){
    vector<StateClass> ut;
    ofstream idUt, val;
    val.open("simplevalues16.csv");
    val << "Action,State,ToState,Team,Player,Name,Value" << "\n";
    idUt.open("ider16.csv");
    int ids[167882];
    int idtil[167882];
    for (int i = 0;i<data.size()-1;i++){
        StateClass s,s2;
        if (i == 0){
            s.period = data[i][1];
            s.status = data[i][2];
            s.manpower = data[i][3];
            s.zone = data[i][4];
            s.home = 0;
            s.goal = 0;
            s2.period = data[i+1][1];
            s2.status = data[i+1][2];
            s2.manpower = data[i+1][3];
            s2.zone = data[i+1][4];
            s2.home = data[i+1][13];
            s2.goal = 0;
            
            int plass = stateExist(states,s);
            if (plass == -1){ // eksisterer ikke i vektoren
                ids[i] = 0;
            }else{ // eksisterer i vektoren
                ids[i] = states[plass].stateId;
            }
            
            int plass2 = stateExist(states,s2);
            if (plass2 == -1){ // eksisterer ikke i vektoren
                idtil[i] = 0;
            }else{ // eksisterer i vektoren
                idtil[i] = states[plass2].stateId;
            }
            
        }else if (i == data.size()-1){
            ids[i] = idtil[i-1];
            idtil[i] = 0;
        }
        else{
            int nesteType = data[i+1][0];
            if (nesteType == 0){
                s2.home = 0;
            }else{
                s2.home = data[i+1][13];
            }
            s2.period = data[i+1][1];
            s2.status = data[i+1][2];
            s2.manpower = data[i+1][3];
            if (nesteType == 120){ // avspark
                s2.zone = 3;
            }else{
                s2.zone = data[i+1][4];
            }
            if (nesteType == 100){ // skuddutfall
                s2.goal = data[i+1][11] - data[i+1][12];
            }else{
                s2.goal = 0;
            }
            if (nesteType == 2){ // offside pass
                data[i+1][0] = 1; // settes til vanlig pasning med outcome 0
                data[i+1][10] = 0;
            }
            ids[i] = idtil[i-1];
            int plass2 = stateExist(states,s2);
            if (plass2 == -1){ // eksisterer ikke i vektoren
                idtil[i] = 0;
            }else{ // eksisterer i vektoren ut
                idtil[i] = states[plass2].stateId;
            }
        }
        
        idUt << ids[i] << "," << idtil[i]<< "\n";
        if (data[i].size() == 15){
            data[i][14] = ids[i];
            data[i].push_back(idtil[i]);
        }else if (data[i].size() == 14){
            data[i].push_back(ids[i]);
            data[i].push_back(idtil[i]);
        }
        double value;
        int action = data[i][0];
        int nextAction = data[i+1][0];
        int home = data[i][13];
        int from = data[i][14];
        int to = data[i][15];
        if (action != 100 && action != 0 && action != 5){
            if (home == 1){
                value = (states[to].actionValue[nextAction] + states[to].reward - states[from].actionValue[action]);
            }else{
                value = -(states[to].actionValue[nextAction] + states[to].reward - states[from].actionValue[action]);
            }
        }
        val << action << "," << from << "," << to << "," << data[i][6] << "," << data[i][7] << "," << "" << "," << value << "\n";
    }
}






















