#pragma once

#include "stdafx.h"
#include "Match.h"
#include "Event.h"
#include "StateClass.h"
#include "tinyxml2.h"

void createSeasonFile();
vector<Match> createVector(int ar);

void createMatch(const char * filename, Match& kamp);


bool qualExist(Event event, int id);
bool compareEvents(const Event& lhs, const Event& rhs);

string playingPattern(Event& event);
string assist(Event& mal, Event& assist);
string goalLocation(Event& mal);
void teamStats(vector<Match> kamper, int lag);
void findAllShots(vector<Match> kamper);
void findAllPasses(vector<Match> kamper);

void findCrossesTeam(vector<Match> kamper, int lag);

void fieldZonePass(Event& pass);
void fieldZonePass2(Event& pass);
void fieldZonePassEnd(Event& pass);
void fieldZonePassEnd2(Event& pass);

void sortEventVector(vector<Event>& v);



void nodeStuff();
void nodeStuffAlt();
void readAllMatches();
void createAllSequences();
void makeSquadFile();

void calculateSequenceLengths(vector<Match> kamper);

// NODE TING UNDER HER


struct StateValue {
	int type;
    int outcome;
	int period;
	int status;
	int manpower;
	int zone;
	int zoneEnd;
	double value;
	double counter;
};

struct State {
	int type;
    int outcome;
	int period;
	int status;
	int manpower;
	int trans[16][16];
	double prob[16][16];
};

vector<State> TransAndProb(vector<vector<int>> data);
bool stateExist(vector<State> states, State s);
int findStatePlace(vector<State> states, State s);
vector<StateValue> setStateValues(vector<State> states, vector<vector<int>> data, vector<double> xg);
vector<vector<double>> calculateEventValues(vector<vector<int>> data, vector<StateValue> states, vector<double> xg);

// FOr alle sekvenser
vector<State> TransAndProbAll(vector<vector<int>> data);
vector<StateValue> setStateValuesAll(vector<State> states, vector<vector<int>> data, vector<double> xg);
vector<vector<double>> calculateEventValuesAll(vector<vector<int>> data, vector<StateValue> states, vector<double> xg);

// VALUE ITERATION

void runModel();
void runModel2();
void runModel3(); // med kontekststate
void runModel4(); // den simple
int stateExist(vector<StateClass> v, StateClass s);
vector<StateClass> findAllStates(vector<vector<int>>& data);
void setNumbers2016(vector<vector<int>>& data, vector<StateClass>& states);
vector<StateClass> findAllStates2(vector<vector<int>>& data); // for den simple, setter også stateid på til-staten for hvert event
vector<StateClass> findAllStates3(vector<vector<int>>& data); // enda simplere
void calculateActionsAndTransitions(vector<vector<int>> data, vector<StateClass>& states);
void calculateTransitionsParallel(vector<vector<int>> data, vector<StateClass>& states);
vector<StateClass> calculateTransitions(vector<vector<int>> data, int &numberOfUniqueStates);
void valueIteration(vector<StateClass>& states, int& numberOfUniqueStates, vector<vector<int>> data);
vector<StateClass> calculateBigStates(vector<StateClass>& smallStates, int& numberOfBig);
double findStateValue(int id, vector<StateClass>& states);
void valueIteration2(vector<StateClass>& states, int& numberOfUniqueStates, vector<vector<int>> data, int& numberOfBig);
void valueIteration3(vector<StateClass>& states, int& numberOfUniqueStates, vector<vector<int>> data);
void valueIteration4(vector<StateClass>& states, int& numberOfUniqueStates, vector<vector<int>> data); // for den simple
void actionValueIteration(vector<StateClass>& states, vector<vector<int>> data); // for action-varianten
void calculateTransitions2(vector<vector<int>> data, int &numberOfUniqueStates, vector<StateClass>& states); // for den simple
void parallelIteration(vector<StateClass>& states, vector<vector<int>> data); // for parallelle MDPEr
void setLengthZone(vector<StateClass> v);
void setSimple16(vector<StateClass> states, vector<vector<int>>& data);





